pipeline {
    agent any 
    environment {
        DOCKERHUB_CREDENTIALS=credentials('dh_cred')
        SSH_KEY=credentials('SSH_KEY')
        USER = 'root'
        PORT = '8080:8080'
        IP_ADRESS = '213.32.95.78'
	    imageVersion="${BUILD_NUMBER}"
        imageName='hamza4devops/java-app'
	    containerName='jenkins_exam'
        EMAIL_TO='hamza.allani.e@gmail.com'
        PROJECT_NAME='Java-App'
    }
    stages {
        stage('Build Docker Image') {
            steps {
                sh 'docker build -t ${imageName}:${imageVersion} -f Dockerfile .'
                echo 'Building Docker Image Successfuly'
            }
        }
        stage('Login to Dockerhub') {
            steps {
                sh 'echo $DOCKERHUB_CREDENTIALS_PSW | docker login -u $DOCKERHUB_CREDENTIALS_USR --password-stdin'
                echo 'Login to Dockerhub Successfuly'
            }
        }
        stage('Push Image to DockerHub') {
            steps {
                sh 'docker push ${imageName}:${imageVersion}'
                echo 'Pushing Image ${imageName}:${imageVersion} Successfuly'
            }
        }
        stage('Clean local env') {
            steps {
                sh 'docker logout $DOCKERHUB_CREDENTIALS_USR'
                sh 'docker image rm ${imageName}:${imageVersion}'
                sh 'docker image rm openjdk:7-alpine'
                echo 'Cleaning Done Successfuly'
            }
        }
        /*
        stage('Deploy to Production Server') {
            steps {
                sh 'chmod 400 $SSH_KEY'
                sh 'ssh -i $SSH_KEY $USER@$IP_ADRESS "echo $DOCKERHUB_CREDENTIALS_PSW | docker login -u $DOCKERHUB_CREDENTIALS_USR --password-stdin \
                    && docker run -d -p ${PORT} ${imageName}:${imageVersion}"'
                echo 'Deploying Done Successfuly'
            }
	    }
                stage('Send Email') {
            steps {
                emailext attachLog: true, body: 'Check console output at $BUILD_URL to view the results.', subject: '$PROJECT_NAME - Build # $BUILD_NUMBER - $BUILD_STATUS!', to: 'hamza.allani.e@gmail.com'
            }
        }
        */
    }
}


